<?php
chdir('../');

require('config/config-SWPHP.inc.php');
include(SWPHP_INC_DIR.'comun.inc.php');

define('SWPHP_PAGINA_ACTUAL', '/');

include_once(SWPHP_COMMON_DIR.'functions/date.php');

$url = $swphp_config['url'];
$sitemap = 'sitemap.xml';

$fp = fopen($sitemap, 'w');

fwrite($fp, '<?xml version="1.0" encoding="UTF-8"?>
<?xml-stylesheet type="text/xsl" href="gss.xsl"?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.google.com/schemas/sitemap/0.84 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">
<!--#Generated by Simple web PHP http://simplewebphp.com/ -->
');

fwrite($fp, buildSitemapUrl($url, getMaxTimestamp(), 'weekly', 1).chr(10));

//PAGINAS
writePaginas($fp, SWPHP::_GetHijas(0, "activo = '1' AND mapaweb = '1'", "peso, id", true));

/*
//PORTAFOLIO
$time = fecha2time($db->GetValueQuery('SELECT MAX(fechayhoraultima) FROM swphp_portafolio', false));
$maximo = 18;
$total = $db->GetCount("SELECT id FROM swphp_portafolio WHERE activo = '1'");
$numpaginas = ($total / $maximo) + 1;
for($c=1; $c<=$numpaginas; $c++)
{
	fwrite($fp, buildSitemapUrl($c > 1 ? "{$url}portafolio/{$c}/" : "{$url}portafolio/", $time, "weekly", 0.6).chr(10));
}
$rows = $db->GetRows("SELECT friendly, fechayhoraultima FROM swphp_portafolio WHERE activo = '1' ORDER BY fechayhoraultima DESC", true, false);
foreach($rows as $row)
{
	fwrite($fp, buildSitemapUrl("{$url}portafolio/{$row['friendly']}/", fecha2time($row['fechayhoraultima']), "weekly", 0.6).chr(10));
}
*/
/*
//PORTAFOLIO PDF
fwrite($fp, buildSitemapUrl("{$url}files/portafolio_phpfreelance.pdf", filemtime("../files/portafolio_phpfreelance.pdf"), "weekly", 0.6).chr(10));
*/

//NOTICIAS
$time = fecha2time($db->GetValueQuery("SELECT SUBSTRING(MAX(fechayhoraultima),1,10) FROM swphp_noticias WHERE activo = '1'", false));
//fwrite($fp, buildSitemapUrl("{$url}noticias/ultimas/", $time, "weekly", 0.5).chr(10));
//fwrite($fp, buildSitemapUrl("{$url}noticias/masleidas/", $time, "weekly", 0.5).chr(10));
$rows = $db->GetRows("SELECT friendly, SUBSTRING(fechayhoraultima,1,10) AS fechayhoraultima FROM swphp_noticias AS n JOIN swphp_noticias_idiomas AS ni ON ni.noticia_id = n.id AND ni.idioma_id = 1 WHERE activo = '1' ORDER BY fechayhoraultima DESC", true, false);
foreach($rows as $row)
{
	fwrite($fp, buildSitemapUrl("{$url}noticias/{$row['friendly']}/", fecha2time($row['fechayhoraultima']), "yearly", 0.1).chr(10));
}


fwrite($fp, '</urlset>');

fclose($fp);

header("Location: ../{$sitemap}");


/* FUNCIONES */

function buildSitemapUrl($loc, $timestamp, $changefreq, $priority)
{
	return sprintf("<url><loc>%s</loc><lastmod>%s</lastmod><changefreq>%s</changefreq><priority>%s</priority></url>", $loc, date('c', $timestamp), $changefreq, str_replace(",",".",sprintf("%.2f", $priority)));
}

function getMaxTimestamp()
{
	global $db;

	$FU1 = $db->GetValueQuery("SELECT SUBSTRING(MAX(fechayhoraultima),1,10) FROM swphp_noticias WHERE activo = '1'", false);
	//$FU2 = $db->GetValueQuery("SELECT MAX(fechayhoraultima) FROM swphp_portafolio WHERE activo = '1'", false);
	//$FU3 = $db->GetValueQuery("SELECT MAX(fecharegistro) FROM swphp_descargas WHERE activo = '1'", false);

	return fecha2time($FU1);
	//return fecha2time(max(max($FU1, $FU2), $FU3));
}

function writePaginas($fp, $paginas, $priority=0.9)
{
	global $url;

	foreach($paginas as $pagina)
	{
		if($pagina['href'])
		{
			fwrite($fp, buildSitemapUrl($url.$pagina['href'], fecha2time($pagina['fechayhoraultima']), "weekly", $priority).chr(10));
		}

		if(!empty($pagina['opciones']))
		{
			writePaginas($fp, $pagina['opciones'], $priority - 0.1);
		}
	}
}