<?php
/**
 * Clase para formar enlaces de paginacion
 *
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-07-30
 *
 */
abstract class LinksPaginacion
{
	static function getLinksPaginacion($url, $pag, $numpags, $total, $n=7, $friendly=true, $querystring='')
	{
		if(!$pag)
		{
			$pag = 1;
		}

		$html = sprintf('<div class="paginacion">
<div class="pag_primera"><a href="%s" title="Primera" %s>&laquo;</a></div>
<div class="pag_anterior"><a href="%s" title="Anterior" %s>&nbsp;&lsaquo;&nbsp;</a></div>
<div class="pag_ultima"><a href="%s" title="Última" %s>&raquo;</a></div>
<div class="pag_siguiente"><a href="%s" title="Siguiente" %s>&nbsp;&rsaquo;&nbsp;</a></div>
',
			LinksPaginacion::getLinkPaginacion($url, $pag, $numpags, "primera", $friendly, $querystring),
			$pag == 1 || $numpags == 0 ? 'class="pag_off"' : '',
			LinksPaginacion::getLinkPaginacion($url, $pag, $numpags, "anterior", $friendly, $querystring),
			$pag == 1 || $numpags == 0 ? 'class="pag_off"' : '',
			LinksPaginacion::getLinkPaginacion($url, $pag, $numpags, "ultima", $friendly, $querystring),
			$pag == $numpags || $numpags == 0 ? 'class="pag_off"' : '',
			LinksPaginacion::getLinkPaginacion($url, $pag, $numpags, "siguiente", $friendly, $querystring),
			$pag == $numpags || $numpags == 0 ? 'class="pag_off"' : ''
			);

		$html .= '<div class="pag_paginas">';
		$ini = $pag - $n;
		if($ini < 1) $ini = 1;
		$fin = $pag + $n;
		if($fin > $numpags) $fin = $numpags;
		for($c=$ini; $c<=$fin; $c++)
		{
			$html .= sprintf('<a href="%s" title="Página %s">%s</a>%s', LinksPaginacion::getLinkPaginacion($url, $pag, $numpags, $c, $friendly, $querystring), $c, $c == $pag ? "<b>{$c}</b>" : $c, $c < $fin ? " | " : "");
		}
		$html .= sprintf("<div class=\"pag_resultados\">%s resultado%s en %s página%s</div></div>\n</div>\n", $total, $total == 1 ? "" : "s", $numpags, $numpags == 1 ? "" : "s");

		return $html;
	}

	static function getLinkPaginacion($url, $pag, $numpags, $cual, $friendly=true, $querystring='')
	{
		if(is_array($querystring))
		{
			$querystring = array_ToQueryString($querystring);
		}

		switch(str_replace('.', '', strtolower($cual)))
		{
			case "primera":
			case "first":
			case "<<":
				$goto = 1;
				break;
			case "anterior":
			case "ant":
			case "previous":
			case "prev":
			case "<":
				$goto = $pag > 1 ? $pag-1 : 1;
				break;
			default:
				$goto = intval($cual);
				break;
			case "siguiente":
			case "sig":
			case "next":
			case ">":
				$goto = $pag < $numpags ? $pag+1 : $numpags;
				break;
			case "ultima":
			case "last":
			case ">>":
				$goto = $numpags;
				break;
		}

		return sprintf("%s%s%s%s",
			$url,
			$friendly ? (substr($url, strlen($url)-1) == '/' ? '' : '/') : (strpos($url, ".php?") === false && strpos($url, "/?") === false ? "?" : "&"),
			$friendly ? ($goto > 1 ? "{$goto}/" : "") : "pag={$goto}",
			$querystring ? ($friendly ? '?'.$querystring : '&'.$querystring) : ''
			);
	}

	static function getTrPaginacion($url, $pag, $numpags, $total, $n=7, $friendly=true, $querystring='')
	{
		return sprintf("<tr>\n\t<td class=\"overline center separado1\" colspan=\"100\">\n%s\n\t</td>\n</tr>\n", LinksPaginacion::getLinksPaginacion($url, $pag, $numpags, $total, $n, $friendly, $querystring));
	}
}
