<?php
/**
 * Clase genérica que hereda de DB_Reg,
 * para manejar registros de tablas de la base de datos
 *
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-04-10
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/classes/SWPHP_Reg.class.php
 *
 */
class SWPHP_Reg extends DB_Reg
{
	protected $_campofechayhoraregistro = 'fechayhoraregistro';
	protected $_campofechayhoraultima = 'fechayhoraultima';
	protected $_campouseridregistro = 'user_idregistro';
	protected $_campouseridultima = 'user_idultima';

	/**
	 * Constructor
	 *
	 * @param DB_Connection $db
	 * @param string $tabla
	 * @param string $campoid
	 */
	public function __construct($tabla, $id=null, &$db_=null, $campoid='id', $campofechayhoraregistro='fechayhoraregistro', $campofechayhoraultima='fechayhoraultima', $campouseridregistro='user_idregistro', $campouseridultima='user_idultima')
	{
		if(is_null($db_))
		{
			global $db;

			$db_ = &$db;
		}

		parent::__construct($db_, $tabla, $campoid);

		$this->_campofechayhoraregistro = $campofechayhoraregistro;
		$this->_campofechayhoraultima = $campofechayhoraultima;
		$this->_campouseridregistro = $campouseridregistro;
		$this->_campouseridultima = $campouseridultima;

		$this->_camposreadonly = array($campofechayhoraregistro, $campofechayhoraultima, $campouseridregistro, $campouseridultima);

		$this->_funcionencriptar = 'SWPHP::_Encrypt';

		$this->Load($id);
	}
	/**
	 * Guarda el registro
	 *
	 * @return bool
	 */
	public function Save()
	{
		unset($this->_data[$this->_campoid]); //por si acaso

		$ahora = date('Y-m-d H:i:s');
		$user_id = empty($_SESSION['user']['id']) ? 0 : $_SESSION['user']['id'];

		$this->_setValue($this->_campofechayhoraultima, $ahora);
		$this->_setValue($this->_campouseridultima, $user_id);

		if($this->_idVacio($this->_id))
		{
			$this->_setValue($this->_campofechayhoraregistro, $ahora);
			$this->_setValue($this->_campouseridregistro, $user_id);

			$query = buildQuery_Insert($this->GetDataFields(), $this->_tabla);
			//SWPHP::_Msg($query);
			if($this->_db->Execute($query))
			{
				$this->_id = $this->_db->Insert_id();
				return true;
			}
			else
			{
				$this->_errores[] = $this->_db->Error();
			}
		}
		elseif($this->Exists())
		{
			$query = buildQuery_Update($this->GetDataFields(), $this->_tabla, array($this->_campoid=>$this->_id));
			//SWPHP::_Msg($query);
			if($this->_db->Execute($query))
			{
				return true;
			}
			else
			{
				$this->_errores[] = $this->_db->Error();
			}
		}
		else
		{
			//Tengo un id pero no existe el registro correspondiente, creo uno con el mismo id
			$this->_setValue($this->_campofechayhoraregistro, $ahora);
			$this->_setValue($this->_campouseridregistro, $user_id);
			$data = $this->_data;
			$data[$this->_campoid] = $this->_id;
			if($this->_db->Execute(buildQuery_Insert($data, $this->_tabla)))
			{
				return true;
			}
			else
			{
				$this->_errores[] = $this->_db->Error();
			}
		}

		return false;
	}
}
