<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty my_currency_format modifier plugin
 *
 * Type:     modifier<br>
 * Name:     currency_format<br>
 * Purpose:  format a number as a fix currency format. (spanish euro)
 * @link 
 * @author   José Carlos Cruz Parra AKA Internia
 * @param int
 * @param bool
 * @param bool
 * @return string
 */
function smarty_modifier_my_currency_format($amount)
{
    $number = number_format($amount, 2, ",", ".");
	$curr_symbol = "&nbsp;&euro;";
	if($amount < 0)
	{
		return "-".$number.$curr_symbol;
	}
	else
	{
		return $number.$curr_symbol;
	}
}

/* vim: set expandtab: */

?>