<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty quitartildes modifier plugin
 *
 * Type:     modifier<br>
 * Name:     quitartildes<br>
 * Purpose:  Quita las tildes y símbolos similares de una cadena.
 *			 Si $modoMayusculas es menor que cero, pasa la cadena a minúsculas,
 *			 si es mayor que cero la pasa a mayúsculas,
 *			 y si es cero (por defecto) no hace nada en este sentido.
 * @link http://www.programadorphpfreelance.com
 * @author   Jose Carlos Cruz Parra AKA Internia <josecarlos@programadorphpfreelance.com>
 * @param string
 * @param int
 * @return string
 */
function smarty_modifier_quitartildes($str, $modoMayusculas=0)
{
    $patrones = array();

	if($modoMayusculas <= 0)
	{
		if($modoMayusculas < 0)
		{
			$str = strtolower($str);
		}
		$patrones[] = array(array("á","à","ä","â"), "a");
		$patrones[] = array(array("é","è","ë","ê"), "e");
		$patrones[] = array(array("í","ì","ï","î"), "i");
		$patrones[] = array(array("ó","ò","ö","ô"), "o");
		$patrones[] = array(array("ú","ù","ü","û"), "u");
	}

	if($modoMayusculas >= 0)
	{
		if($modoMayusculas > 0)
		{
			$str = strtoupper($str);
		}
		$patrones[] = array(array("Á","À","Ä","Â"), "A");
		$patrones[] = array(array("É","È","Ë","Ê"), "E");
		$patrones[] = array(array("Í","Ì","Ï","Î"), "I");
		$patrones[] = array(array("Ó","Ò","Ö","Ô"), "O");
		$patrones[] = array(array("Ú","Ù","Ü","Û"), "U");
	}

	foreach($patrones as $patron)
	{
		$str = str_replace($patron[0], $patron[1], $str);
	}

	return $str;
}

/* vim: set expandtab: */

?>
