<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty url_format modifier plugin
 *
 * Type:     modifier<br>
 * Name:     url_format<br>
 * Purpose:  format a string as url
 * @link http://www.programadorphpfreelance.com
 * @author   José Carlos Cruz Parra AKA Internia
 * @param string
 * @param bool
 * @return string
 */
function smarty_modifier_url_format($url, $shorturl=false)
{
    $url = html_entity_decode($url);

	if($shorturl) {
		$indexphp_pos = strpos($url, "index.php?");
		$quest_pos = strpos($url, "?");
		$url = substr($url, 0, $indexphp_pos).substr($url, $quest_pos+1);
		$sharp_pos = strpos($url, "#");
		if($sharp_pos)
		{
			$sharp_txt = substr($url, $sharp_pos);
			$url = substr($url, 0, $sharp_pos);
		}
		$items = split("&", $url);
		$url = "";
		foreach ($items as $item) {
			$url .= substr($item, 0, strpos($item, "="))."-";
			$url .= substr($item, strpos($item, "=")+1)."-";
		}
		$url = substr($url, 0, strlen($url)-1).".html";
		if($sharp_pos)
			$url .= $sharp_txt;
	}
	return htmlentities(str_replace(" ", "20%", $url));
}

/* vim: set expandtab: */

?>
