<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-09-24
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/contacto/install.php
 *
 */

/**
 * Realiza las actuaciones particulares de la instalación de este módulo:
 * - Crear las variables de configuración
 *
 * @param array $info
 * @return bool
 */
function contacto_instalar($info)
{
	$ok = true;
	$arr = contacto_getConfigVars();
	foreach($arr as $key=>$value)
	{
		$ok &= SWPHP::_CreateConfigValue($key, '', 'contacto', $value['info'], $value['texto']);
	}

	return $ok;
}
/**
 * Realiza las actuaciones particulares de la desinstalación de este módulo
 * - Eliminar las variables de configuración
 *
 * @param array $info
 * @return bool
 */
function contacto_desinstalar($info)
{
	return SWPHP::_DeleteAllConfigValues('contacto');
}
/**
 * Obtiene las variables de configuración para este módulo
 *
 * @return array
 */
function contacto_getConfigVars()
{
	return array(
		'nombre'=>array(
			'info'=>'tag=input;type=text;size=30;maxlength=60',
			'texto'=>'Nombre para contacto',
			),
		'direccion1'=>array(
			'info'=>'tag=input;type=text;size=30;maxlength=60',
			'texto'=>'Dirección (calle y número)',
			),
		'direccion2'=>array(
			'info'=>'tag=input;type=text;size=30;maxlength=60',
			'texto'=>'Dirección (línea opcional)',
			),
		'localidad'=>array(
			'info'=>'tag=input;type=text;size=30;maxlength=60',
			'texto'=>'Localidad (nombre)',
			),
		'provincia'=>array(
			'info'=>'tag=input;type=text;size=30;maxlength=60',
			'texto'=>'Provincia',
			),
		'codigopostal'=>array(
			'info'=>'tag=input;type=text;size=10;maxlength=5',
			'texto'=>'Código postal',
			),
		'telefono'=>array(
			'info'=>'tag=input;type=text;size=20;maxlength=20',
			'texto'=>'Teléfono',
			),
		'fax'=>array(
			'info'=>'tag=input;type=text;size=20;maxlength=20',
			'texto'=>'Fax',
			),
		'movil'=>array(
			'info'=>'tag=input;type=text;size=20;maxlength=20',
			'texto'=>'Móvil',
			),
		'movil2'=>array(
			'info'=>'tag=input;type=text;size=20;maxlength=20',
			'texto'=>'Móvil 2',
			),
		'email'=>array(
			'info'=>'tag=input;type=text;size=30;maxlength=60',
			'texto'=>'Email de contacto',
			),
		'facebook'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Dirección URL en Facebook',
			),
		'twitter'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Dirección URL en Twitter',
			),
		'myspace'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Dirección URL en My Space',
			),
		'linkedin'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Dirección URL en LinkedIn',
			),
		'youtube'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Dirección URL en YouTube',
			),
		'googlebuzz'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Dirección URL en Google Buzz',
			),
		'googleplus'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Dirección URL en Google Plus',
			),
		'googlemaps'=>array(
			'info'=>'tag=textarea;cols=60;rows=3',
			'texto'=>'Dirección URL en Google Maps',
			),
		'skype'=>array(
			'info'=>'tag=input;type=text;size=30;maxlength=80',
			'texto'=>'Usuario de Skype',
			),
		'horario1'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Horario (línea 1)',
			),
		'horario2'=>array(
			'info'=>'tag=input;type=text;size=60;maxlength=255',
			'texto'=>'Horario (línea 2)',
			),
		'imagen'=>array(
			'info'=>"tag=select;options=SWPHP::_GetFilesExtForHTMLSelect(SWPHP_MODULES_DIR.'contacto/img/', array('jpg','gif','png','jpeg'))",
			'texto'=>'Imagen (si no se pone mapa)',
			),
		'privacidad'=>array(
			'info'=>"tag=select;options=SWPHP::_Rows2AssocTree(SWPHP_DBPREFIX.'paginas AS p JOIN '.SWPHP_DBPREFIX.'paginas_idiomas AS pi ON pi.pagina_id IN(p.id)', 'pi.titulo', 'p.id', 'p.padre_id',  '1 ORDER BY p.padre_id, p.peso', array('0', ''))",
			'texto'=>'Política de privacidad',
			),
		);
}