<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-04-07
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/admin/estadisticas/index.php
 *
 */

require_once($swphp_module_dir.'inc/classes/KPTL_User.class.php');
include_once(SWPHP_COMMON_DIR.'functions/date.php');

$kptl_config = SWPHP::_GetConfigValues('kapitaltruth', false, 'kptl_config');

$rows = KPTL_User::query_all(false);

$age = 0;
$points = 0;
$cont = 0;
$contage = 0;
$var = 0;

if(is_array($rows) && sizeof($rows) > 0)
{
    foreach($rows as $row)
    {
        $cont += 1;
        $points += $row['puntos_show'];
        if($row['edad'])
        {
        	$age += $row['edad'];
        	$contage++;
        }
    }

    $average_points = $points / $cont;
   	$average_age = $age / $contage;

   	$dist = 0;
    foreach($rows as $row)
    {
        $dist += pow($row['puntos_show'] - $average_points, 2);
    }

    $var_points = 0;
    if($cont-1 != 0)
    {
        $var_points = $dist / ($cont - 1);
    }

    $coef_points = sqrt($var_points);

    $var_age = 0;
    if($contage-1 != 0)
    {
        $var_age = $dist / ($contage - 1);
    }

    $coef_age = sqrt($var_points);

    $dif = $kptl_config['tesoroactual'] - ($kptl_config['tesorototal'] - $points);

    if(isset($_GET['sent']) && isset($_GET['control']) && $_GET['control'] == $_SESSION['control'])
    {
        $mensaje = '<h2>Estadísticas de KPTL</h2>
<h3>'.$swphp_config['dominio'].'</h3>
<table>
<tr><td>Cantidad de experimentadores</td><td style="text-align:right">'.$cont.' usuarios</td></tr>
<tr><td>Promedio de puntos</td><td style="text-align:right">'.$average_points.' puntos</td></tr>
<tr><td>Coeficiente de variación de puntos</td><td style="text-align:right">'.$coef_points.'</td></tr>
<tr><td>Cuántos indicaron su edad</td><td style="text-align:right">'.$contage.' usuarios</td></tr>
<tr><td>Promedio de edad</td><td style="text-align:right">'.$average_age.' años</td></tr>
<tr><td>Coeficiente de variación de edad</td><td style="text-align:right">'.$coef_age.'</td></tr>
<tr><td>Puntos totales en el Tesoro</td><td style="text-align:right">'.$kptl_config['tesorototal'].' puntos</td></tr>
<tr><td>Puntos actuales en el Tesoro</td><td style="text-align:right">'.$kptl_config['tesoroactual'].' puntos</td></tr>
</table>
';
        if($dif != 0)
        {
            $mensaje .= '<p>Hay un descuadre entre los puntos de los usuarios ('.$points.') y el contador del tesoro ('.($kptl_config['tesorototal'] - $kptl_config['tesoroactual']).')</b>';
        }

        $mensaje .= '
<table>
<tr><td>Nombre de la moneda</td><td>'.$kptl_config['KPTL_punto'].'</td></tr>
<tr><td>URL</td><td>'.$swphp_config['url'].'</td></tr>
</table>
';

        if(SWPHP::_EnviarEmail($kptl_config['emailautor'], 'Estadísticas de KPTL - '.$swphp_config['dominio'], $mensaje, null, null, null, $error))
        {
            SWPHP::_Msg(l('Estadísticas enviadas correctamente', 'kapitaltruth'), 'check');
        }
        else
        {
            SWPHP::_Msg(l('No se ha podido enviar las estadísticas', 'kapitaltruth').'<br />'.$error, 'error');
        }
    }

    $smarty->assign(array(
    	'cont'=>$cont,
    	'average_points'=>$average_points,
    	'average_age'=>$average_age,
    	'contage'=>$contage,
    	'coef_points'=>$coef_points,
    	'coef_age'=>$coef_age,
    	'puntostotalestesoro'=>$kptl_config['tesorototal'],
    	'puntosactualestesoro'=>$kptl_config['tesoroactual'],
    	));

    if($dif != 0)
    {
    	SWPHP::_Msg(l('Hay un descuadre entre los [KPTL_puntos] de los usuarios', 'kapitaltruth').' ('.$points.') '.l('y el contador del tesoro', 'kapitaltruth').' ('.($kptl_config['tesorototal'] - $kptl_config['tesoroactual']).')', 'aviso');
    }
}
else
{
	SWPHP::_Msg(l('No existen experimentadores', 'kapitaltruth'), 'aviso');
}

$admin_template = "{$swphp_module_templates_dir}admin/estadisticas/generales.tpl";
?>