<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-06-10
 * para Francisco Ortega
 *
 */
class KPTL_Graficos
{
	public static function GetEvolucionPuntos($ini, $fin, $user_id, $leyenda1="")
	{
		if(DaysDifference($ini, $fin) > 900)
		{
			return l('El rango es demasiado amplio, indica un periodo más breve', 'kapitaltruth');
		}
		elseif(DaysDifference($ini, $fin) > 152)
		{
			return KPTL_Graficos::getEvolucionPuntosPorMeses($ini, $fin, $user_id, $leyenda1);
		}
		else
		{
			return KPTL_Graficos::getEvolucionPuntosPorDias($ini, $fin, $user_id, $leyenda1);
		}
	}

	public static function GetEvolucionValoraciones($ini, $fin, $user_id, $leyenda1="")
	{
		if(DaysDifference($ini, $fin) > 900)
		{
			return l('El rango es demasiado amplio, indica un periodo más breve', 'kapitaltruth');
		}
		elseif(DaysDifference($ini, $fin) > 152)
		{
			return KPTL_Graficos::getEvolucionValoracionesPorMeses($ini, $fin, $user_id, $leyenda1);
		}
		else
		{
			return KPTL_Graficos::getEvolucionValoracionesPorDias($ini, $fin, $user_id, $leyenda1);
		}
	}

	public static function GetEvolucionPuntosComparadaConMedia($ini, $fin, $user_id, $leyenda1="")
	{
		if(DaysDifference($ini, $fin) > 900)
		{
			return l('El rango es demasiado amplio, indica un periodo más breve', 'kapitaltruth');
		}
		elseif(DaysDifference($ini, $fin) > 152)
		{
			return KPTL_Graficos::GetEvolucionPuntosComparadaConMediaPorMeses($ini, $fin, $user_id, $leyenda1);
		}
		else
		{
			return KPTL_Graficos::GetEvolucionPuntosComparadaConMediaPorDias($ini, $fin, $user_id, $leyenda1);
		}
	}

	public static function GetEvolucionPuntosComparadaConOtro($ini, $fin, $user_id, $comp_id, $leyenda1="", $leyenda2="")
	{
		if(DaysDifference($ini, $fin) > 900)
		{
			return l('El rango es demasiado amplio, indica un periodo más breve', 'kapitaltruth');
		}
		elseif(DaysDifference($ini, $fin) > 152)
		{
			return KPTL_Graficos::GetEvolucionPuntosComparadaConOtroPorMeses($ini, $fin, $user_id, $comp_id, $leyenda1, $leyenda2);
		}
		else
		{
			return KPTL_Graficos::GetEvolucionPuntosComparadaConOtroPorDias($ini, $fin, $user_id, $comp_id, $leyenda1, $leyenda2);
		}
	}

	public static function GetEvolucionValoracionesComparadaConMedia($ini, $fin, $user_id)
	{
		if(DaysDifference($ini, $fin) > 900)
		{
			return l('El rango es demasiado amplio, indica un periodo más breve', 'kapitaltruth');
		}
		elseif(DaysDifference($ini, $fin) > 152)
		{
			return KPTL_Graficos::GetEvolucionValoracionesComparadaConMediaPorMeses($ini, $fin, $user_id);
		}
		else
		{
			return KPTL_Graficos::GetEvolucionValoracionesComparadaConMediaPorDias($ini, $fin, $user_id);
		}
	}

	public static function GetEvolucionValoracionesComparadaConOtro($ini, $fin, $user_id, $comp_id, $leyenda1="", $leyenda2="")
	{
		if(DaysDifference($ini, $fin) > 900)
		{
			return l('El rango es demasiado amplio, indica un periodo más breve', 'kapitaltruth');
		}
		elseif(DaysDifference($ini, $fin) > 152)
		{
			return KPTL_Graficos::GetEvolucionValoracionesComparadaConOtroPorMeses($ini, $fin, $user_id, $comp_id, $leyenda1, $leyenda2);
		}
		else
		{
			return KPTL_Graficos::GetEvolucionValoracionesComparadaConOtroPorDias($ini, $fin, $user_id, $comp_id, $leyenda1, $leyenda2);
		}
	}

	private static function getEvolucionPuntosPorDias($ini, $fin, $user_id, $leyenda1="")
	{
		$dias = array();
    	$medias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);

		while($ini < $fin)
		{
			$cuantos++;

			$dias[$ini] = KPTL_Calculon::getSaldo($user_id, $ini);

			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2]+$cuantos, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $dias);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>$leyenda1 ? $leyenda1 : l('Mis [KPTL_puntos]', 'kapitaltruth'),
    		"chco"=>"0000FF",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Días', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kaptitaltruth'), $min, l('Med.', 'kaptitaltruth'), $med, l('Máx.', 'kaptitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

		return KPTL_Graficos::buildChartImg($params);
	}

	private static function getEvolucionValoracionesPorDias($ini, $fin, $user_id, $leyenda1="")
	{
		$dias = array();
    	$medias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);

		while($ini < $fin)
		{
			$cuantos++;

			$dias[$ini] = KPTL_Calculon::getValoracion($user_id, $ini);

			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2]+$cuantos, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $dias);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>$leyenda1 ? $leyenda1 : l('Mi valoración', 'kapitaltruth'),
    		"chco"=>"0000FF",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Días', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

		return KPTL_Graficos::buildChartImg($params);
	}

	private static function GetEvolucionPuntosComparadaConMediaPorDias($ini, $fin, $user_id, $leyenda1="")
	{
		$dias = array();
    	$medias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);

		while($ini < $fin)
		{
			$cuantos++;

			$dias[$ini] = KPTL_Calculon::getSaldo($user_id, $ini);
			$medias[$ini] = KPTL_Calculon::getSaldoMedia($ini);

			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2]+$cuantos, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $dias, $medias);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>sprintf("%s|%s", $leyenda1 ? $leyenda1 : l('Mis [KPTL_puntos]', 'kapitaltruth'), l('Media usuarios', 'kapitaltruth')),
    		"chco"=>"0000FF,ff9d09",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Días', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

    	return KPTL_Graficos::buildChartImg($params);
	}

	private static function GetEvolucionPuntosComparadaConOtroPorDias($ini, $fin, $user_id, $comp_id, $leyenda1="", $leyenda2="")
	{
		$dias = array();
    	$dias2 = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);

		while($ini < $fin)
		{
			$cuantos++;

			$dias[$ini] = KPTL_Calculon::getSaldo($user_id, $ini);
			$dias2[$ini] = KPTL_Calculon::getSaldo($comp_id, $ini);

			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2]+$cuantos, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $dias, $dias2);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>sprintf("%s|%s", $leyenda1 ? $leyenda1 : l('Mis [KPTL_puntos]', 'kapitaltruth'), $leyenda2 ? $leyenda2 : l('Comparado', 'kapitaltruth')),
    		"chco"=>"0000FF,ff9d09",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Días', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

    	return KPTL_Graficos::buildChartImg($params);
	}

	private static function GetEvolucionValoracionesComparadaConMediaPorDias($ini, $fin, $user_id)
	{
		$dias = array();
    	$medias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);

		while($ini < $fin)
		{
			$cuantos++;

			$dias[$ini] = KPTL_Calculon::getValoracion($user_id, $ini);
			$medias[$ini] = KPTL_Calculon::getValoracionMedia($ini);

			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2]+$cuantos, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $dias, $medias);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>sprintf("%s|%s", l('Mi valoración', 'kapitaltruth'), l('Media usuarios', 'kapitaltruth')),
    		"chco"=>"0000FF,ff9d09",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Días', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

    	return KPTL_Graficos::buildChartImg($params);
	}

	private static function getEvolucionPuntosPorMeses($ini, $fin, $user_id, $leyenda1="")
	{
		$meses = array();
    	$medias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);
		$dateF = descomponerfecha($fin);

		$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], 1, $date[0]));
		$fin = date("Y-m-d", mktime(0, 0, 0, $dateF[1], 0, $dateF[0]));

		while($ini < $fin)
		{
			$meses[substr($ini,0,7)] = KPTL_Calculon::getSaldoPeriodo($user_id, $ini, date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 0, $date[0])));
			$cuantos++;
			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 1, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $meses);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>$leyenda1 ? $leyenda1 : l('Mis [KPTL_puntos]', 'kapitaltruth'),
    		"chco"=>"0000FF",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Meses', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

		return KPTL_Graficos::buildChartImg($params);
	}

	private static function getEvolucionValoracionesPorMeses($ini, $fin, $user_id, $leyenda1="")
	{
		$meses = array();
    	$medias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);
		$dateF = descomponerfecha($fin);

		$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], 1, $date[0]));
		$fin = date("Y-m-d", mktime(0, 0, 0, $dateF[1], 0, $dateF[0]));

		while($ini < $fin)
		{
			$meses[substr($ini,0,7)] = KPTL_Calculon::getValoracionPeriodo($user_id, $ini, date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 0, $date[0])));
			$cuantos++;
			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 1, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $meses);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>$leyenda1 ? $leyenda1 : l('Mi valoración', 'kapitaltruth'),
    		"chco"=>"0000FF",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Meses', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

		return KPTL_Graficos::buildChartImg($params);
	}

	private static function GetEvolucionPuntosComparadaConMediaPorMeses($ini, $fin, $user_id, $leyenda1="")
	{
		$meses = array();
    	$medias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);
		$dateF = descomponerfecha($fin);

		$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], 1, $date[0]));
		$fin = date("Y-m-d", mktime(0, 0, 0, $dateF[1], 0, $dateF[0]));

		while($ini < $fin)
		{
			$meses[substr($ini,0,7)] = KPTL_Calculon::getSaldoPeriodo($user_id, $ini, date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 0, $date[0])));
			$medias[substr($ini,0,7)] = KPTL_Calculon::getSaldoMedia($ini);
			$cuantos++;
			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 1, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $meses, $medias);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>sprintf("%s|%s", $leyenda1 ? $leyenda1 : l('Mis [KPTL_puntos]', 'kapitaltruth'), l('Media usuarios', 'kapitaltruth')),
    		"chco"=>"0000FF,ff9d09",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Meses', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

    	return KPTL_Graficos::buildChartImg($params);
	}

	private static function GetEvolucionPuntosComparadaConOtroPorMeses($ini, $fin, $user_id, $comp_id, $leyenda1="", $leyenda2="")
	{
		$meses = array();
    	$meses2 = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);
		$dateF = descomponerfecha($fin);

		$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], 1, $date[0]));
		$fin = date("Y-m-d", mktime(0, 0, 0, $dateF[1], 0, $dateF[0]));

		while($ini < $fin)
		{
			$meses[substr($ini,0,7)] = KPTL_Calculon::getSaldoPeriodo($user_id, $ini, date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 0, $date[0])));
			$meses2[substr($ini,0,7)] = KPTL_Calculon::getSaldoPeriodo($comp_id, $ini, date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 0, $date[0])));
			$cuantos++;
			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 1, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $meses, $meses2);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>sprintf("%s|%s", $leyenda1 ? $leyenda1 : l('Mis [KPTL_puntos]', 'kapitaltruth'), $leyenda2 ? $leyenda2 : l('Comparado', 'kapitaltruth')),
    		"chco"=>"0000FF,ff9d09",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Meses', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

    	return KPTL_Graficos::buildChartImg($params);
	}

	private static function GetEvolucionValoracionesComparadaConMediaPorMeses($ini, $fin, $user_id)
	{
		$meses = array();
    	$medias = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);
		$dateF = descomponerfecha($fin);

		$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], 1, $date[0]));
		$fin = date("Y-m-d", mktime(0, 0, 0, $dateF[1], 0, $dateF[0]));

		while($ini < $fin)
		{
			$meses[substr($ini,0,7)] = KPTL_Calculon::getValoracionPeriodo($user_id, $ini, date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 0, $date[0])));
			$medias[substr($ini,0,7)] = KPTL_Calculon::getValoracionMedia($ini);
			$cuantos++;
			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 1, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $meses, $medias);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>sprintf("%s|%s", l('Mi valoración', 'kapitaltruth'), l('Media usuarios', 'kapitaltruth')),
    		"chco"=>"0000FF,ff9d09",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Meses', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

    	return KPTL_Graficos::buildChartImg($params);
	}

	private static function GetEvolucionValoracionesComparadaConOtroPorMeses($ini, $fin, $user_id, $comp_id, $leyenda1="", $leyenda2="")
	{
		$meses = array();
    	$meses2 = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);
		$dateF = descomponerfecha($fin);

		$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], 1, $date[0]));
		$fin = date("Y-m-d", mktime(0, 0, 0, $dateF[1], 0, $dateF[0]));

		while($ini < $fin)
		{
			$meses[substr($ini,0,7)] = KPTL_Calculon::getValoracionPeriodo($user_id, $ini, date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 0, $date[0])));
			$meses2[substr($ini,0,7)] = KPTL_Calculon::getValoracionPeriodo($comp_id, $ini, date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 0, $date[0])));
			$cuantos++;
			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1]+$cuantos, 1, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $meses, $meses2);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>sprintf("%s|%s", $leyenda1 ? $leyenda1 : l('Mis [KPTL_puntos]', 'kapitaltruth'), $leyenda2 ? $leyenda2 : l('Comparado', 'kapitaltruth')),
    		"chco"=>"0000FF,ff9d09",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Meses', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

    	return KPTL_Graficos::buildChartImg($params);
	}

	private static function GetEvolucionValoracionesComparadaConOtroPorDias($ini, $fin, $user_id, $comp_id, $leyenda1="", $leyenda2="")
	{
		$dias = array();
    	$dias2 = array();
    	$cuantos = 0;

		$date = descomponerfecha($ini);

		while($ini < $fin)
		{
			$cuantos++;

			$dias[$ini] = KPTL_Calculon::getValoracion($user_id, $ini);
			$dias2[$ini] = KPTL_Calculon::getValoracion($comp_id, $ini);

			$ini = date("Y-m-d", mktime(0, 0, 0, $date[1], $date[2]+$cuantos, $date[0]));
		}

		list($ceil, $min, $med, $max, $chd, $dlabels) = KPTL_Graficos::getCeilMinMedMaxChdDlabels($cuantos, $dias, $dias2);

		$params = array(
    		"cht"=>"lc",
    		//"chtt"=>"",
    		"chts"=>"333333,12",
    		"chs"=>"900x300",
    		"chd"=>$chd,
    		"chdl"=>sprintf("%s|%s", $leyenda1 ? $leyenda1 : l('Mis [KPTL_puntos]', 'kapitaltruth'), $leyenda2 ? $leyenda2 : l('Comparado', 'kapitaltruth')),
    		"chco"=>"0000FF,ff9d09",
    		"chxt"=>"x,y,x,y,r",
    		"chxr"=>sprintf("0,0,%s|1,0,%s|4,0,%s", $cuantos, $ceil, $ceil),
    		"chxl"=>"0:|".$dlabels.sprintf("|2:|%s|3:|%s|4:|%s(%s)|%s(%s)|%s(%s)", l('Días', 'kapitaltruth'), l('[KPTL_Puntos]', 'kapitaltruth'), l('Mín.', 'kapitaltruth'), $min, l('Med.', 'kapitaltruth'), $med, l('Máx.', 'kapitaltruth'), $max),
    		"chxp"=>sprintf("2,50|3,50|4,%s,%s,%s", $min, $med, $max),
    		"chxs"=>"4,6666CC,10,-1,t,999999",
    		"chxtc"=>"4,-900",
    		);

    	return KPTL_Graficos::buildChartImg($params);
	}

	private static function buildChartImg($params)
	{
		$src = "http://chart.apis.google.com/chart?";
		foreach($params as $key=>$value)
		{
			$src .= sprintf("%s=%s&", $key, $value);
		}

		return sprintf("<img src=\"%s\" alt=\"\" width=\"%s\" height=\"%s\" />", $src, substr($params["chs"],0,strpos($params["chs"],"x")), substr($params["chs"],strpos($params["chs"],"x")+1));
	}

	private static function dia2label($dia, $cuantos)
	{
		if($cuantos > 10)
		{
			if($cuantos > 45)
			{
				$diasolo = substr($dia, 8);
				switch(intval($diasolo))
				{
					case 1:
						return $dia;
					case 15:
						return $diasolo;
					default:
						return "";
				}
			}

			//return substr($dia, 5);
			return substr($dia, 8);
		}

		return $dia;
	}

	private static function getCeilMinMedMaxChdDlabels($cuantos, $dias, $arr2=array(0))
	{
		if($cuantos > 0)
		{
			$min = min($dias);
			$med = round(array_sum($dias)/$cuantos);
			$max = max($dias);

			$ceil = ceil(max($max, max($arr2)) / 100) * 100;
			if($ceil == 0)
			{
				$ceil = 100;
			}
		}
		else
		{
			$min = 0;
			$med = 0;
			$max = 0;

			$ceil = 0;
		}

		$chd = "t";
		$sep = ":";
		$dlabels = "";
		$dsep = "";
		foreach($dias as $key=>$value)
		{
			$chd .= sprintf("%s%s", $sep, number_format($value*100/$ceil, 2, '.', ''));
			$sep = ",";

			$dlabels .= sprintf("%s%s", $dsep, KPTL_Graficos::dia2label($key, $cuantos));
			$dsep = "|";
		}
		if($arr2)
		{
			$sep = "|";
			foreach($arr2 as $key=>$value)
			{
				$chd .= sprintf("%s%s", $sep, number_format($value*100/$ceil, 2, '.', ''));
				$sep = ",";
			}
		}

		return array($ceil, $min, $med, $max, $chd, $dlabels);
	}
}