<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2013-03-02
 *
 */
class SCU
{
	/**
	 * Realiza las funciones del cron
	 *
	 */
	public static function Cron()
	{
		$modomotor = SWPHP::_GetConfigValue('modomotor', 'scu');

		SWPHP::_Msg(l('Modo motor:', 'scu').' '.$modomotor, 'info');

		if($modomotor == 'cron')
		{
			$ultima = SWPHP::_GetConfigValue('fechayhoraultima', 'scu');
			$ahora = date('Y-m-d H:i:s');

			SWPHP::_Msg(l('Última:', 'scu').' '.$ultima, 'info');
			SWPHP::_Msg(l('Ahora:', 'scu').' '.$ahora, 'info');

			SCU::Enviar();

			SWPHP::_SetConfigValue('fechayhoraultima', $ahora, 'scu');
		}
		else
		{
			SWPHP::_Msg(l('La ejecución de evíos no está configurada para realizarse por cron.', 'scu'), 'prohibido');
		}

		SWPHP::_Msg(l('TERMINADO', 'scu'), 'check');
	}

	public static function Enviar()
	{
		include_once(SWPHP_COMMON_DIR.'functions/validations.php');
		require(SWPHP_MODULES_DIR.'scu/inc/classes/SCU_Enviador.class.php');

		global $db;

		$enviador = new SCU_Enviador();

		$horaactual = date('H:i:s');

		$scu_config = SWPHP::_GetConfigValues('scu', false);
		$email_config = SWPHP::_GetConfigValues('configuracion_email', false);

		$enviador->SetRemitenteEmail($scu_config['emailenvios'] ? $scu_config['emailenvios'] : $email_config['emailenvios']);
		$enviador->SetRemitenteEmailNombre($scu_config['nombreenvios'] ? $scu_config['nombreenvios'] : $email_config['nombreenvios']);
		$enviador->SetRemitenteSMS($scu_config['remitentesms']);

		$mediosActivos = $db->GetArrayForHTMLSelectQuery("SELECT m.id, m.clave FROM ".SWPHP_DBPREFIX."scu_medios AS m WHERE m.activo = 1", null, false);

		$users_ids = $db->GetValuesQuery("SELECT DISTINCT mu.user_id FROM ".SWPHP_DBPREFIX."scu_mensajes_users AS mu WHERE mu.procesado = 0 LIMIT 50", false);
		foreach($users_ids as $user_id)
		{
			SWPHP::_Log("User Id. {$user_id}");

			$mediosUser = $db->GetArrayForHTMLSelectQuery("SELECT m.id, m.clave FROM ".SWPHP_DBPREFIX."scu_medios AS m JOIN ".SWPHP_DBPREFIX."scu_medios_users AS mu ON m.id = mu.medio_id AND mu.user_id = '{$user_id}' WHERE m.activo = '1'", null, false);

			$temas = $db->GetArrayForHTMLSelectQuery("SELECT t.id, t.clave FROM ".SWPHP_DBPREFIX."scu_temas AS t JOIN ".SWPHP_DBPREFIX."scu_temas_users AS tu ON t.id = tu.tema_id AND tu.user_id = '{$user_id}'", null, false);
			$row = $db->GetRow("SELECT id, clave FROM ".SWPHP_DBPREFIX."scu_temas WHERE clave = 'ADMIN'");
			$tema_id_ADMIN = $row['id'];
			$temas[$tema_id_ADMIN] = $row['clave'];
			$temas_size = sizeof($temas);

			SWPHP::_Log("Suscrito a {$temas_size} temas");

			if($temas_size > 0)
			{
				$mensajes = $db->GetRows("SELECT m.id, m.tema_id, mu.user_id, m.asunto, m.textohtml, m.textocorto, m.medios"
					." FROM ".SWPHP_DBPREFIX."scu_mensajes AS m"
					." JOIN ".SWPHP_DBPREFIX."scu_mensajes_users AS mu ON mu.mensaje_id = m.id AND mu.procesado = 0 AND mu.user_id = '{$user_id}'"
					." WHERE m.tema_id IN (".implode(',', array_keys($temas)).") ORDER BY m.fechayhoraregistro ASC", true, false);
				foreach($mensajes as $mensaje)
				{
					$medios = $mediosUser;
					$mediosMensaje = $mensaje['medios'] ? explode(",", $mensaje['medios']) : array();
					foreach($mediosMensaje as $medio_id)
					{
						if(!isset($medios[$medio_id]))
						{
							$medios[$medio_id] = $mediosActivos[$medio_id];
						}
					}
					$medios_size = sizeof($medios);

					SWPHP::_Log(sprintf("Mensaje Id.%s,\tTema %s,\tA enviar por %u", $mensaje['id'], $temas[$mensaje['tema_id']], $medios_size));

					foreach($medios as $medio_id=>$medio_clave)
					{
						SWPHP::_Log("Enviar por {$medio_clave}");

						$ok = $enviador->EnviarMensaje($medio_clave, $user_id, $mensaje['asunto'], $mensaje['textohtml'], $mensaje['textocorto'], $error, $destinatario, $mensaje['id']);
						$db->Execute(sprintf("INSERT INTO ".SWPHP_DBPREFIX."scu_envios(mensaje_id, user_id, medio_id, resultadobool, resultadostring, fechayhora, destinatario) VALUES('%u', '%u', '%u', '%s', '%s', '%s', '%s')", $mensaje['id'], $user_id, $medio_id, $ok ? 1 : 0, $error, date('Y-m-d H:i:s'), $destinatario));
						$db->Execute(sprintf("UPDATE ".SWPHP_DBPREFIX."scu_mensajes_users SET procesado = 1, fechayhoraproceso = '%s' WHERE mensaje_id = '%u' AND user_id = '%u'", date('Y-m-d H:i:s'), $mensaje['id'], $user_id));

						SWPHP::_Log(sprintf("Resultado: %s %s", $mensaje['id'], $temas[$mensaje['tema_id']], $medio_clave, $ok ? 'OK' : 'ERROR', $error));
					}
				}
			}

			//Los que no se tienen que enviar el enviador no los marca como procesados, así que los marcamos nosotros
			$db->Execute(sprintf("UPDATE ".SWPHP_DBPREFIX."scu_mensajes_users SET procesado = 1, fechayhoraproceso = '%s' WHERE procesado = 0 AND user_id = '%u'", date('Y-m-d H:i:s'), $user_id));

			//TODO: limit de proceso (ahora mismo sólo está el limit de 50 en el select de users id
		}

		SWPHP::_Log('Terminado');
	}
}
?>