<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2010-01-08
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/session.inc.php
 */

ini_set('session.gc_maxlifetime', SWPHP_SESSION_EXPIRE_TIME); //Tiempo para el recolector de basura
ini_set('session.gc_probability', defined('SWPHP_SESSION_GC_PROBABILITY') ? SWPHP_SESSION_GC_PROBABILITY : 10);
ini_set('session.gc_divisor', defined('SWPHP_SESSION_GC_DIVISOR') ? SWPHP_SESSION_GC_DIVISOR : 1000);
ini_set('session.save_handler', 'user'); //Usar funciones personalizadas para manejar las sesiones
ini_set('session.save_path', SWPHP_DBNAME); //Nombre de la base de datos
session_name(SWPHP_DBPREFIX.'sessions'); //Nombre de la tabla donde se guardarán las sesiones
session_set_save_handler('open', 'close', 'read', 'write', 'destroy', 'gc'); //Registrar las funciones personalizadas
register_shutdown_function('session_write_close'); //Para evitar el error que se produce por un bug en php 5.2.x (los objetos son destruidos antes de escribir y cerrar sesión)

session_start();


//FUNCIONES PARA EL MANEJO DE SESIONES

function open($save_path, $session_name)
{
	global $sess_con;
	$sess_con = DB_Connection::Factory(SWPHP_DBHOST, SWPHP_DBPORT, SWPHP_DBNAME, SWPHP_DBUSER, SWPHP_DBPASS, true, SWPHP_CHARSET, SWPHP_DEBUG, defined('SWPHP_DBCLASS') ? SWPHP_DBCLASS : null);

	//Recuperar una sesión
	if(isset($_GET['sessid']) && isset($_GET['sesskey']) && is_numeric($_GET['sesskey']) && $_GET['sesskey'] > 0)
	{
		if($sess_con->Exists($_GET['sessid'], "id", session_name(), "WHERE clave = '{$_GET['sesskey']}'"))
		{
			//Asignamos el id de la sesión a recuperar
			session_id($_GET['sessid']);
		}
	}

	return true;
}

function close()
{
	global $sess_con;
	return $sess_con->Close();
}

function read($session_id)
{
	global $sess_con;

	//Generar una nueva clave (utilizable luego para los enlaces desde donde se quiera recuperar sesión)
	$_SESSION["key"] = mt_rand(100000000, 9999999999);
	$_SESSION["id"] = session_id();

	$result = DB_ResultSet::Factory($sess_con->GetExtension());
	$result->Set = $sess_con->Execute("SELECT data FROM ".session_name()." WHERE id='$session_id'");
	return ($reg = $result->FetchRow()) ? $reg[0] : "";
}

function write($session_id, $data)
{
	global $sess_con;

	$data = addcslashes($data, "\\'");

	$sess_con->Execute("UPDATE ".session_name()." SET data = '$data', time = '".time()."', clave = '{$_SESSION["key"]}' WHERE id = '$session_id'");
	if($sess_con->AffectedRows() != 1)
	{
		return (bool)$sess_con->Execute("INSERT INTO ".session_name()."(id,ip,time,data) VALUES('$session_id','".SWPHP_CLIENT_IP."','".time()."','$data')");
	}
	return true;
}

function destroy($session_id)
{
	global $sess_con;
	return (bool)$sess_con->Execute("DELETE FROM ".session_name()." WHERE id = '$session_id'");
}

function gc($max_time)
{
	global $sess_con;
	return (bool)$sess_con->Execute("DELETE FROM ".session_name()." WHERE `time` < (".time()." - ".$max_time.")");
}
