<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-02-03
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * index.php
 */

require('config/config-SWPHP.inc.php');
require(SWPHP_INC_DIR.'comunini.inc.php');

$padre_id = 0;
$paginaActual = '';

if($swphp_config['mantenimiento'])
{
	$swphp_pagina->SetValues(
		l('Página en mantenimiento'),
		'',
		l('Este sitio web está cerrado temporalmente para llevar a cabo tareas de mantenimiento.'),
		l('pagina, web, cerrada, mantenimiento'),
		'<p>'.l('Este sitio web está cerrado temporalmente para llevar a cabo tareas de mantenimiento.').'</p><p>'.l('Por favor, vuelve a visitarnos más tarde.').'</p>',
		'exclamation.png'
		);

	define('SWPHP_PAGINA_ACTUAL', $paginaActual);
	unset($paginaActual);
}
else
{
	$esteril_pagina_id = 0;
	$esteril_paginaActual = '';

	$filtrosIdioma = array(
		"pi.idioma_id = '{$_SESSION['SWPHP_IDIOMA_ACTUAL']}'",
		/* [2017-02-13] Antes de usar el idioma en las URLs se autodetectaba según la página, pero ya no */
		//"pi.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'",
		//"pi.idioma_id IN('".implode("','", array_keys($swphp_idiomas))."')",
		);

	for($c=0; $c<SWPHP_MAX_GET_PAGES && isset($_GET["page{$c}"]) && $_GET["page{$c}"] != ''; $c++)
	{
		$friendly = string2friendly($_GET["page{$c}"]); //Si es correcto no le hará ningún cambio
		$paginaActual .= "{$friendly}/";

		foreach($filtrosIdioma as $filtroIdioma)
		{
			$row = $db->GetRow("SELECT p.id, p.esteril, pi.idioma_id, pi.textoenlace, pi.title FROM ".SWPHP_DBPREFIX."paginas AS p JOIN ".SWPHP_DBPREFIX."paginas_idiomas AS pi ON p.id = pi.pagina_id AND {$filtroIdioma} WHERE pi.friendly = '{$friendly}' AND (p.padre_id = '{$padre_id}' || p.padre_id = '1')", true, false);
			if($row)
			{
				break;
			}
		}

		if(!empty($row))
		{
			$_SESSION['SWPHP_IDIOMA_ACTUAL'] = $row['idioma_id'];

			$swphp_pagina_id = $row['id'];

			if($row['esteril'])
			{
				$esteril_pagina_id = $swphp_pagina_id;
				$esteril_paginaActual = $paginaActual;
			}

			$padre_id = $row['id'];

			SWPHP::$breadcrumb->Add($paginaActual, $row['textoenlace'], $row['title']);
		}
		else
		{
			if($esteril_pagina_id > 0)
			{
				$paginaActual = $esteril_paginaActual;
				$swphp_pagina_id = $esteril_pagina_id;
			}
			elseif(SWPHP::_GetConfigValue('moduloenportada', 'paginas'))
			{
				$paginaActual = '/';
			}
			else
			{
				$swphp_pagina->NotFound();
			}

			break;
		}
	}

	define('SWPHP_PAGINA_ACTUAL', $paginaActual);
	unset($paginaActual);

	if(!$swphp_pagina->GetNotFound())
	{
		if(isset($swphp_pagina_id))
		{
			$swphp_pagina->LoadFromId($swphp_pagina_id);
			$swphp_portada = false;
		}
		else
		{
			//Intento cargar la página de portada, primero la configurada como tal,
			//y si no la que tenga friendly vacío

			foreach($filtrosIdioma as $filtroIdioma)
			{
				$row = $db->GetRow("SELECT p.id, p.esteril, pi.idioma_id FROM ".SWPHP_DBPREFIX."paginas AS p JOIN ".SWPHP_DBPREFIX."paginas_idiomas AS pi ON p.id = pi.pagina_id AND {$filtroIdioma} WHERE p.id = '".SWPHP::_GetConfigValue('portada', 'paginas')."'", true, false);
				if($row)
				{
					$_SESSION['SWPHP_IDIOMA_ACTUAL'] = $row['idioma_id'];

					$swphp_pagina_id = $row['id'];

					break;
				}
			}

			if(isset($swphp_pagina_id))
			{
				$swphp_pagina->LoadFromId($swphp_pagina_id);
			}
			else
			{
				$swphp_pagina->LoadFromFriendly('', 0, true);
			}

			$swphp_portada = true;
		}

		$contenido = $swphp_pagina->GetContenido();

		//Comprobamos si se está pidiendo un módulo
		$pos = strpos($contenido, "[swphp:modulo]");
		if($pos !== false)
		{
			$pos += 14;
			$swphp_mod_clave = substr($contenido, $pos, strpos($contenido, "[/swphp]", $pos)-$pos);
			$swphp_module_dir = sprintf(SWPHP_MODULES_DIR."%s/", $swphp_mod_clave);
			$file = "{$swphp_module_dir}index.php";
			//Comprobar si existe el módulo
			if(is_dir($swphp_module_dir) && is_file($file))
			{
				$row = $db->GetRow(sprintf("SELECT id, activo, version FROM ".SWPHP_DBPREFIX."modulos WHERE clave = '%s'", addcslashes($swphp_mod_clave, "'")), true, false);

				//Comprobar si está activo en la base de datos
				if(isset($row['activo']) && $row['activo'])
				{
					//Cojo el nivel de permiso y lo meto en una variable para que esté disponible desde el módulo
					$swphp_permiso_id = SWPHP::_GetPermiso($row['id']);

					//Comprobar si el usuario tiene permiso
					if($swphp_permiso_id > SWPHP_PERMISO_ACCESOPROHIBIDO)
					{
						//Cargar módulo
						$swphp_module_templates_dir = "../../../".SWPHP_MODULES_DIR."{$swphp_mod_clave}/tpl/";
						SWPHP::_LoadModuleLang($swphp_mod_clave);
						SWPHP::_Include('functions.inc.php', $swphp_module_dir);
						if(SWPHP::_Include('xajax.inc.php', $swphp_module_dir))
						{
							require(SWPHP_COMMON_DIR.'classes/SWPHP_Xajax.class.php');

							$xajax->processRequest();
						}

						$corrector = (SWPHP_PAGINA_ACTUAL == '/' ? 0 : substr_count(SWPHP_PAGINA_ACTUAL, '/')) - 1;
						switch($corrector)
						{
							case -1:
								for($c=SWPHP_MAX_GET_PAGES+1; $c>0; $c--)
								{
									if(isset($_GET['page'.($c-1)]))
									{
										$_GET['page'.$c] = $_GET['page'.($c-1)];
									}
								}

								$_GET['page0'] = $swphp_mod_clave;
								break;
							case 0:
								//nada;
								break;
							default:
								for($c=0; $c<SWPHP_MAX_GET_PAGES; $c++)
								{
									if(isset($_GET['page'.$c]))
									{
										$_GET['page'.$c] = isset($_GET['page'.($c+1)]) ? $_GET['page'.($c+1)] : '';
									}
									else
									{
										break;
									}
								}
								break;
						}

						if(empty($_GET['page1']) && $swphp_pagina->GetValue('simodulo') > 1)
						{
							$swphp_pagina->SetProcesarContenido(true);
						}
						else
						{
							$swphp_pagina->SetValue('contenido', '');
						}

						SWPHP::_CheckVersionModulo($swphp_mod_clave, $row['version']);

						include($file);
					}
					elseif(isset($_SESSION['user']['autenticado']) && $_SESSION['user']['autenticado'])
					{
						$swphp_pagina->SetValue('contenido', 'No autorizado');
					}
					else
					{
						//SWPHP::_Msg('No autorizado', 'prohibido');
						$sinUso = '';
						SWPHP::_PedirLogin($sinUso, true);
					}
				}
				else
				{
					$swphp_pagina->SetValue('contenido', 'El módulo '.$swphp_mod_clave.' no está registrado o no está activo');
				}
			}
			else
			{
				$swphp_pagina->SetValue('contenido', 'No se encuentra el módulo '.$swphp_mod_clave);
			}
		}
		else
		{
			//Se mostrará el contenido de la página pero antes lo procesamos en busca de plugins, etc. desde comunfin.inc.php
			$swphp_pagina->SetProcesarContenido(true);
		}
	}
}

$swphp_pagina_id = $swphp_pagina->GetId();

$swphp_menuprincipal = SWPHP::_GetMenuPrincipal();
$swphp_menucontextual = SWPHP::_GetMenuContextual($swphp_pagina_id);

$smarty->assign('swphp_menuprincipal', $swphp_menuprincipal);
$smarty->assign('swphp_menucontextual', $swphp_menucontextual);
$smarty->assign('swphp_localizador', SWPHP::$breadcrumb->GetItems());

require(SWPHP_INC_DIR.'comunfin.inc.php');
